// Copyright David Abrahams 2006. Distributed under the Boost
// Software License, Version 1.0. (See accompanying
// file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
#ifndef BOOST_PP_IS_ITERATING

# ifndef NEW_DWA2006324_HPP
#  define NEW_DWA2006324_HPP

#  include <boost/preprocessor/iteration/iterate.hpp>
#  include <boost/preprocessor/arithmetic/div.hpp>
#  include <boost/preprocessor/arithmetic/mod.hpp>
#  include <boost/preprocessor/seq/seq.hpp>
#  include <boost/preprocessor/seq/enum.hpp>
#  include <boost/preprocessor/seq/elem.hpp>
#  include <boost/preprocessor/seq/fold_left.hpp>
#  include <boost/preprocessor/cat.hpp>
#  include <boost/preprocessor/repetition/repeat.hpp>
#  include <boost/preprocessor/repetition/enum_params.hpp>

# define BOOST_FORWARD_param1(n) (BOOST_PP_CAT(A,n) const& BOOST_PP_CAT(x,n))
# define BOOST_FORWARD_param0(n) (BOOST_PP_CAT(A,n) & BOOST_PP_CAT(x,n))


# define BOOST_FORWARD_fold_param(s, state, n)          \
    (                                                   \
        BOOST_PP_DIV(BOOST_PP_SEQ_HEAD(state),2)        \
    )(                                                  \
        BOOST_PP_SEQ_HEAD(BOOST_PP_SEQ_TAIL(state))     \
        BOOST_PP_CAT(                                   \
            BOOST_FORWARD_param                         \
          , BOOST_PP_MOD(BOOST_PP_SEQ_HEAD(state),2)    \
        )(n)                                            \
    )                                                   

# define BOOST_FORWARD_seq_number(z,n,ignored) (n)

# define BOOST_FORWARD_seq_count_to(n) \
    BOOST_PP_REPEAT_1(n, BOOST_FORWARD_seq_number, ~)

// given:
//
//   (constness)((~) (x)(y)(z)... )
//
// yields (x)(y)(z)...
# define BOOST_FORWARD_seq_result(state) \
    BOOST_PP_SEQ_TAIL(BOOST_PP_SEQ_HEAD(BOOST_PP_SEQ_TAIL(state)))

# define BOOST_FORWARD_param_seq(arity, constness)       \
    BOOST_FORWARD_seq_result(                            \
        BOOST_PP_SEQ_FOLD_LEFT(                          \
            BOOST_FORWARD_fold_param                     \
          , (constness)((~))                             \
          , BOOST_FORWARD_seq_count_to(arity)            \
        ))

template <class Ptr>
Ptr new_()
{
    typedef typename Ptr::element_type pointee;
    return Ptr(new pointee);
}

# ifndef BOOST_FORWARD_MAX_ARITY
#  define BOOST_FORWARD_MAX_ARITY 4
# endif 

# define BOOST_PP_ITERATION_PARAMS_1 (3, (1, BOOST_FORWARD_MAX_ARITY, "new.hpp"))
# include BOOST_PP_ITERATE()

# undef BOOST_FORWARD_param_seq
# undef BOOST_FORWARD_seq_result
# undef BOOST_FORWARD_seq_count_to
# undef BOOST_FORWARD_seq_number
# undef BOOST_FORWARD_fold_param
# undef BOOST_FORWARD_param0
# undef BOOST_FORWARD_param1

# endif // NEW_DWA2006324_HPP

#elif BOOST_PP_ITERATION_DEPTH() == 1

# define BOOST_PP_ITERATION_PARAMS_2 (3, (0, (1 << BOOST_PP_ITERATION()) - 1, "new.hpp"))
# include BOOST_PP_ITERATE()


#elif BOOST_PP_ITERATION_DEPTH() == 2

# define BOOST_FORWARD_arity BOOST_PP_RELATIVE_ITERATION(1)
# define BOOST_FORWARD_constness BOOST_PP_ITERATION()

template <class Ptr, BOOST_PP_ENUM_PARAMS(BOOST_FORWARD_arity, class A) >
Ptr new_( BOOST_PP_SEQ_ENUM( BOOST_FORWARD_param_seq(BOOST_FORWARD_arity, BOOST_FORWARD_constness) ))
{
    typedef typename Ptr::element_type pointee;
    return Ptr(new pointee(BOOST_PP_ENUM_PARAMS(BOOST_FORWARD_arity, x)));
}

# undef BOOST_FORWARD_constness
# undef BOOST_FORWARD_arity

#endif 
